#!/bin/bash 
# 当/var/log/syslog大于1GB时 
# 自动将其备份，并清空 
# 注意这里awk的使用 
function_fail()
{
  echo $1
  return 0
}
function_check()
{
    cap=2097152
    curcap=`du -sk /var/log | awk '{print $1}'`
    size=0
    for file in `du -sk /var/log/* | sort -nr |awk '{print $2}'`  
    do  
         if [ "$file" = "." ]; then
    	    continue
  	 fi
  	 if [ "$file" = ".." ]; then
    	    continue
  	 fi
         size=`du -sk $file | awk '{print $1}'`  
         if [[ $curcap -gt $cap ]] ; then  
                ((curcap =curcap-size))
		rm -rf "$file"  
        	echo $curcap  
         fi  
                  
    done  
}
function_clean()
{
  if ! [ -f $1 ]; then 
    function_fail "file $1 not exist!" 
    return 1 
  fi 
  if [ `ls -l $1|awk '{print $5}'` -gt $((1024*100000)) ];
  then 
    rm -rf $1 # 清空 
  fi
  return 0
}
function_lock()
{
  if [ -f "$1" ]; then
    rm -rf "$1"
    exit 0
  fi
  touch "$1"
  return 0
}
function_lock "/tmp/clean_lock"

for file in $(ls -a "/var/log"); do
  if [ "$file" = "." ]; then
    continue
  fi
  if [ "$file" = ".." ]; then
    continue
  fi
  function_clean "/var/log/$file"
done
function_check
rm -rf "/tmp/clean_lock"
exit 0
